from pyuspostalservice.endpoints.base.base_endpoint import USPSEndpoint
from pyuspostalservice.interfaces import (
    IPostable,
)
from pyuspostalservice.models.usps import Response
from pyuspostalservice.types import (
    JSON,
    USPSRequestParams,
)


class ResponsesCreateOrUpdateEndpoint(
    USPSEndpoint,
    IPostable[Response, USPSRequestParams],

):
    def __init__(self, client, parent_endpoint=None) -> None:
        USPSEndpoint.__init__(self, client, "create-or-update", parent_endpoint=parent_endpoint)
        IPostable.__init__(self, Response)

    def post(self, data: JSON | None = None, params: USPSRequestParams | None = None) -> Response:
        """
        Performs a POST request against the /responses/create-or-update endpoint.

        Parameters:
            data (dict[str, Any]): The data to send in the request body.
            params (dict[str, int | str]): The parameters to send in the request query string.
        Returns:
            Survey: The parsed response data.
        """
        return self._parse_one(Response, super()._make_request("POST", data=data, params=params).json())
